
package de.ivu.elect.jee.entity;

import java.util.ArrayList;
import java.util.List;

/**
 * Knoten, um Baum der abhängiogen/zugehörigen Entitäten aufbauen zu können
 */
public class EntityFachlichAbhaengigNode {

  private final String attributeName;

  private final Entity< ? , ? > entity;

  private final List<EntityFachlichAbhaengigNode> children = new ArrayList<>();

  public EntityFachlichAbhaengigNode(String attributeName, Entity< ? , ? > entity) {
    this.attributeName = attributeName;
    this.entity = entity;
  }

  public String getAttributeName() {
    return attributeName;
  }

  public Entity< ? , ? > getEntity() {
    return entity;
  }

  public List<EntityFachlichAbhaengigNode> getChildren() {
    return children;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (!(o instanceof EntityFachlichAbhaengigNode)) return false;

    EntityFachlichAbhaengigNode that = (EntityFachlichAbhaengigNode) o;

    if (!entity.equals(that.entity)) return false;

    return true;
  }

  @Override
  public int hashCode() {
    return entity.hashCode();
  }
}
